query:
	transaction |
	select | select | call |
	dml | dml |
	ddl ;

transaction:
	START TRANSACTION | COMMIT | ROLLBACK ;

select:
	SELECT /* RESULTSET_SAME_DATA_IN_EVERY_ROW */ select_item AS f1
	FROM join_list
	where;

call:
	CALL /* RESULTSET_SAME_DATA_IN_EVERY_ROW */ procedure_name ( @inout1 ) |
	SET @inout1 = 0 ; CALL procedure_name ( @inout1 ) ; SELECT /* RESULTSET_SINGLE_INTEGER_ONE */ IF(@inout1 IN (0,1), 1, 999);

dml:
	update | 
#	delete |	# bug46746
	insert_select ;

update:
	pick_table_name UPDATE $table_name SET _field = _digit ;

insert_select:
	pick_table_name INSERT INTO $table_name SELECT * FROM $table_name LIMIT 0 ;

delete:
	pick_table_name DELETE FROM $table_name LIMIT 1 ;

select_item:
	_digit |
	function_name ( _digit ) |
	function_name ( _field ) ;

join_list:
	selectable_object;

selectable_object:
	_table |
	pick_table_name $table_name |
	pick_view_name $view_name ;

where:
	|
	WHERE argument operator argument;

argument:
	_field |
	_digit |
	function_name ( argument ) ;

operator:
	< | <> ;

ddl:
	table_ddl |
	function_ddl |
	table_ddl |
	view_ddl |
	procedure_ddl;
# |	trigger_ddl ;	# bug46748

table_ddl:
	pick_table_name create_table | pick_table_name create_table | pick_table_name create_table |
	pick_table_name alter_table ;
	pick_table_name drop_table ; create_table ;

function_ddl:
	pick_function_name create_function | pick_function_name create_function | pick_function_name create_function |
	pick_function_name drop_function ; create_function ;

procedure_ddl:
	pick_procedure_name create_procedure | pick_procedure_name create_procedure | pick_procedure_name create_procedure |
	pick_procedure_name drop_procedure ; create_procedure ;

trigger_ddl:
	pick_trigger_name create_trigger | pick_trigger_name create_trigger | pick_trigger_name create_trigger |
	pick_trigger_name drop_trigger ; create_trigger ;

view_ddl:
	pick_view_name create_view | pick_view_name create_view | pick_view_name create_view |
	pick_view_name alter_view | pick_view_name drop_view ; create_view ;

pick_function_name:
	{ $function_name = 'func_'.$prng->int(1,3) ; return undef } ;

pick_procedure_name:
	{ $procedure_name = 'proc_'.$prng->int(1,3) ; return undef } ;

pick_table_name:
#	{ $table_name = $prng->arrayElement($executors->[0]->tables()) ; return undef } |
	{ $table_name = 'table_'.$prng->int(1,3) ; return undef } ;

pick_trigger_name:
	{ $trigger_name = 'trigger_'.$prng->int(1..9) ; return undef } ;

pick_view_name:
	{ $view_name = 'view_'.$prng->int(1..3) ; return undef } ;

function_name:
	{ 'func_'.$prng->int(1,3) } ;

procedure_name:
	{ 'proc_'.$prng->int(1,3) } ;

create_function:
	CREATE FUNCTION $function_name (in1 INTEGER) RETURNS INTEGER deterministic function_body ;

create_procedure:
	CREATE PROCEDURE $procedure_name (INOUT inout1 INT) procedure_body ;

create_table:
	CREATE temporary TABLE $table_name ( `int` INTEGER, `int_key` INTEGER, KEY (`int_key`) ) select ;

create_view:
	CREATE OR REPLACE ALGORITHM = view_algorithm VIEW $view_name AS select ;

alter_view:
	ALTER ALGORITHM = view_algorithm VIEW $view_name AS select ;

drop_view:
	DROP VIEW $view_name ;

view_algorithm:
	UNDEFINED | MERGE | TEMPTABLE ;

temporary:
	;
#	| TEMPORARY ;	# bug46747

create_trigger:
	pick_table_name CREATE TRIGGER $trigger_name trigger_time trigger_event ON $table_name FOR EACH ROW update ;

trigger_time:
	BEFORE | AFTER;

trigger_event:
	INSERT ;

drop_trigger:
	DROP TRIGGER $trigger_name;

drop_table:
	DROP TABLE IF EXISTS $table_name;

alter_table:
	ALTER TABLE $table_name ADD COLUMN `default` INTEGER DEFAULT _digit |
	ALTER TABLE $table_name CHANGE COLUMN `default` `default` INTEGER DEFAULT _digit ;

drop_function:
	DROP FUNCTION $function_name ;

drop_procedure:
	DROP PROCEDURE $procedure_name ;

function_body:
	RETURN _digit |
	RETURN in1 ;

procedure_body:
	BEGIN SELECT COUNT(DISTINCT select_item ) INTO inout1 FROM join_list where ; END |
	BEGIN SELECT select_item FROM join_list where ; END ;

deterministic:
	| DETERMINISTIC | NOT DETERMINISTIC ;
